
.486
.model flat, stdcall
option casemap :none
   
;Includes + Libs ; <***************************************************
   
include  include\windows.inc
include  include\masm32.inc
include  include\gdi32.inc
include  include\user32.inc
include  include\kernel32.inc
include  include\advapi32.inc
include  include\Comctl32.inc
include  include\comdlg32.inc
include  include\shell32.inc
include  include\oleaut32.inc
include  include\ole32.inc
include  include\dialogs.inc
include  include\winmm.inc
include  include\msimg32.inc
   
   
includelib  lib\masm32.lib
includelib  lib\gdi32.lib
includelib  lib\user32.lib
includelib  lib\kernel32.lib
includelib  lib\advapi32.lib
includelib  lib\Comctl32.lib
includelib  lib\comdlg32.lib
includelib  lib\shell32.lib
includelib  lib\oleaut32.lib
includelib  lib\ole32.lib
includelib  lib\winmm.lib
includelib  lib\msimg32.lib
   
include include\macros.asm
   
;Protos ; <************************************************************
   

WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD
   
.CONST ; <*************************************************************
IDD_DLG1 equ 101
TIMER1 equ 1
Stars equ 200 ; number of stars
.DATA ; <**************************************************************
   
   
   
ClassName db "Win32asm_class",0
DisplayName db " FPU SAMPLE by TOM",0
   
    
   
noir dd 0000000h
   
pt dd Stars dup (0,0,0) ;x,y,z+color
   
ptX dd 0
ptY dd 0
   
random dd 0
   
num256 REAL4 400.00 ; starting cluster size
   
.DATA? ; <*************************************************************
hInstance dd ?
hmainDC dd ?
hmainbmp dd ?
WindowRect    	RECT		<?>
MyRect RECT <?>
rClientWindow	RECT		<?>
hbmp		HANDLE		?
chdc		HDC		?

PictureW dd ?
PictureH dd ?
hDialog DD ?
dRect RECT <>
; left   dd ?
; top    dd ?
; right  dd ?
; bottom dd ?
.CODE ; <**************************************************************
   
start:
   
   
invoke GetModuleHandle, NULL
mov hInstance, eax
INVOKE InitCommonControls   
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR WndProc, 0
INVOKE ExitProcess, 0
    ; -------------------------------------------------------------------------

    WndProc PROC uses edx ecx ebx esi edi hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD
    ; -------------------------------------------------------------------------
   
    LOCAL hdc:HDC
    LOCAL ps:PAINTSTRUCT
  
     .IF eax == WM_INITDIALOG
     
 INVOKE  GetWindowRect,hDialog,offset dRect
       mov     eax,dRect.right
       sub     eax,dRect.left
       mov     PictureW,eax
       mov     eax,dRect.bottom
       sub     eax,dRect.top
       mov     PictureH,eax
INVOKE LoadResource, hInstance, eax
		INVOKE LockResource, eax
		mov esi, eax

    .IF eax ==  WM_CLOSE 
     INVOKE EndDialog, hWnd, 0
 .ENDIF   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_PAINT
   
    invoke BeginPaint,hWnd, ADDR ps
    mov hdc,eax
   
    ; ------------------------------------------------------------- PIXEL
    xor esi,esi
   
    @starfield:
   
    call starfield
   
    invoke SetPixel, hmainDC, ptX, ptY, eax
   
    add esi,12 ; next stars
    cmp esi,Stars*12 ; end?
    jne @starfield
   
    ; ------------------------------------------------------------- PIXEL
   
    invoke BitBlt,hdc,0,0,WindowRect.right,WindowRect.bottom,chdc,0,0,SRCCOPY
		invoke EndPaint,hWnd,addr ps
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_KEYDOWN
   
    cmp wParam, VK_ESCAPE
    je destroy
   
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_TIMER
   
    invoke FillRect, hmainDC, addr MyRect,noir
    invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_CREATE
    INVOKE  GetWindowRect,hDialog,offset dRect
       mov     eax,dRect.right
       sub     eax,dRect.left
       mov     PictureW,eax
       mov     eax,dRect.bottom
       sub     eax,dRect.top
       mov     PictureH,eax
    invoke CreateSolidBrush,noir
    mov noir,eax
   
    invoke SetTimer, hWnd, TIMER1, 10, NULL
    ;  main
   
    invoke GetDC, hWnd
    mov hdc, eax
   
    mov esi,PictureW
    mov edi,PictureH
   
   
    invoke CreateCompatibleDC, hdc
    mov dword ptr [hmainDC],eax
   
    invoke CreateCompatibleBitmap, hdc, esi, edi
    mov dword ptr [hmainbmp],eax
   
    invoke SelectObject, [hmainDC], eax
   
    invoke ReleaseDC,hWnd, hdc
    ;  main
   
   
   
   
   
    ; ?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==? Create stars coord.
    invoke GetTickCount
    mov random,eax
   
    xor esi,esi
   
    CREATE_STARS:
   
    push eax
   
    imul ax,cx
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    add al,3
    mov dword ptr [pt+esi],eax
   
    pop eax
    xor eax,[$+esi]
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    mov dword ptr [pt+esi+4], eax
   
   
    imul ax,cx
    xor ax,si
    mov random,eax
   
   
    mov ecx,eax
    mov ch,1
    and ecx,0fffh
    mov dword ptr [pt+esi+8], ecx
   
    add esi,12
    cmp esi,Stars*12
    jne CREATE_STARS
    ; ?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==? Create stars coord.
   
   
    .ELSEIF eax == WM_CLOSE
    destroy:
    invoke PostQuitMessage,NULL
    invoke DeleteDC, [hmainDC]
    invoke DeleteObject, [hmainbmp]
    invoke DeleteObject, noir
    invoke KillTimer, hWnd, TIMER1
    .ENDIF
   
   
    xor eax,eax
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    ret
   
   
    starfield:
   
    finit
   
    dec dword ptr [pt+esi+8]
   
    fild word ptr [pt+esi+8] ;z
    fld num256
   
    fild dword ptr [pt+esi] ;x
    fmul st(0),st(1)
    fdiv st(0),st(2)
    fistp dword ptr [ptX]
  mov     eax,PictureW
        shr     eax,1
        add     ptX,eax ; center
   
   
    fild dword ptr [pt+esi+4] ;y
    fmul st(0),st(1)
    fdiv st(0),st(2)
    fistp dword ptr [ptY]
    mov     eax,PictureH
        shr     eax,1
        add     ptY,eax

   
   
   
    mov ecx,PictureW
    mov edx,PictureH
   .if ptX > ecx || ptY > edx
    call CHANGE_STARS
    .ENDIF
   
   
    xor eax,eax
    mov al,byte ptr [pt+esi+8+3] ; color
    mov ah,al
    shl eax,8
    mov al,ah
   
   
    .IF byte ptr [pt+esi+8+3] != 0FFh ; color white max
    inc byte ptr [pt+esi+8+3]
    .ENDIF
   
   
    retn
   
   
    CHANGE_STARS: ;change stars coord.
   
    mov eax, random
   
    push eax
   
    imul ax,cx
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    add al,3
    mov dword ptr [pt+esi],eax
   
    pop eax
    xor eax,[$+esi]
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    mov dword ptr [pt+esi+4], eax
   
   
    imul ax,cx
    xor ax,si
    mov random,eax
   
   
    mov ecx,eax
    mov ch,1
    and ecx,0fffh
    mov dword ptr [pt+esi+8], ecx ; fface z et raz la couleur
   
   
    retn
    ;-------------------------------------------------------------------------
WndProc ENDP

END start